---
title: Use nginx to deploy the website generated by teedoc to the server
keywords: teedoc, deployment, nginx
desc: Use nginx to deploy the website generated by teedoc to the server
---


Here is a brief introduction. For more detailed usage, please find documents or tutorials yourself, such as `HTTPS`

## Install nginx

The server installs `nginx`, such as `ubuntu`:
```
sudo apt update
sudo apt install nginx
```

## Configure and start nginx service

```
nginx -t
```
You can see the configuration file path, usually `/etc/nginx/nginx.conf`, you can see that the file contains `/etc/nginx/site-enabled/`

Check the following `default` file, you can see the statement
```
listen 80 default_server;
root /var/www/html;
```
That is to monitor port `80`, the root directory of the website is here, we copy our website content here, that is, copy all files in the `out` directory to the `/var/www/html/` directory

then:
```
service nginx start
```

You can access the website by visiting `http://ip:80`, `:80` can also be omitted, or it can be modified to other ports, because the website that has not been registered in China is not allowed to use port `80`, and the overseas server is no limit
