---
title: SEO(为搜索引擎优化)
keywords: teedoc, SEO, 搜索优化, 搜索引擎收录
desc: 使用 teedoc 如何做 SEO（加速搜索引擎收录网站和页面）
---

`SEO`: `Search Engine Optimization`, 即为搜索引擎优化，为了让自己的网站能被搜索引擎收录，这样用户才能通过搜索引擎搜索到我们的网站，我们需要做一些事情：


## 页面关键词和描述

在每个页面添加关键词和描述, 如果不添加影响也不大, 建议根据文章内容添加, 比如`.md`文件头(本页的源文)
```markdown
---
title: SEO(为搜索引擎优化)
keywords: teedoc, SEO, 搜索优化, 搜索引擎收录
desc: 使用 teedoc 如何做 SEO（加速搜索引擎收录网站和页面）
---

```

这会自动为文章添加一个标题， 并且将关键词和描述添加到`HTML`文件中，方面搜索引擎抓取

另外，由于页面会根据这个标题生成一个一级标题，所以文章最好不要再使用一级标题，直接使用二级标题，比如:

```markdown
---
title: SEO(为搜索引擎优化)
keywords: teedoc, SEO, 搜索优化, 搜索引擎收录
desc: 使用 teedoc 如何做 SEO（加速搜索引擎收录网站和页面）
---

## 简介

这里是简介

## 目录二

```

## 图片 alt 信息

在 markdown 中使用使用时, 尽量添加图片描述

错误:
```markdown
![](url)
```

正确:
```markdown
![图片描述](url)
```

## 网站地图

会生成一份网站地图到`/sitemap.xml`，以及一份机器人爬取规则到`/robots.txt`中，可以到搜索引擎的站长后台中提交这个`sitemap`的`url`，这样搜索引擎就会来抓取信息了

可以在 `site_config.json` 中设置`robots`键值来阻止爬虫爬取某些文件或内容， 格式参见[使用说明](./start.md)中对`robots`键值的说明



## 页尾备案信息

在中国国内，网站都需要备案才能被搜索引擎收录，在`config.json`中添加你的网站的备案信息，注意备案信息必须要和域名一致，否则无效

